<?php
/**
Dies ist die Eingangsdatei, die fr die normalen Benutzer zur Verfgung steht.
In diesem Teil des Programms werden die Repositories verwaltet. Dazu stehen den
Benutzer Werkzeuge zum anlegen und lschen zur Verfgung.

Die gesamtadministration wird von einem anderen Teil des Programms aus 
gemacht
*/
include("lib/smarty/libs/Smarty.class.php"); 
include("lib/SVNAdmin/svnadmin.class.php");
include("lib/share/IniController.class.php");

//holen des Authentifizierten Benutzes
$user = $_SERVER['PHP_AUTH_USER'];
$password = $_SERVER['PHP_AUTH_PW'];

$svn = new SVNAdmin($user, $password);

$smarty = new Smarty();
$smarty->template_dir = "tpl/";
$smarty->compile_dir = "tpl_c/";
//$smarty->debugging = true;


$do = $_GET['do'];

switch ($do) {
	case "list":
		
		$rep_list = $svn->getUserRepositories($user);
		
		//Was soll angezeigt werden
		$smarty->assign("tpl", "list_rep.tpl");
		
		//Inhalt der Daten die angezeigt werden sollen
		$smarty->assign("repositories", $rep_list);
		if (is_array($rep_list))
		{
			//Alle Benutzer die vorhanden sind anzeigen
			foreach ($rep_list as $rep => $rights) {
				$user_list[$rep] = array_diff($svn->getAllRegisteredUsers(),array_keys($svn->getRepositoryUsers($rep)));
			}
		}
		
		$smarty->assign("user_list", $user_list);
		
		break;
		
	case "add":
	
		$smarty->assign("tpl", "add_rep.tpl");
	
		break;

	case "save":
	
		//Unterscheiden zwischen den Aktionen
		switch ($_POST['type']) {
			case "add_rep":
				
				//ein neues Repository hinzufgen
				$res = $svn->createRepository($_POST['rep_name']);
				if ($res)
					$smarty->assign("msg", "Repository wurde angelegt");
				else {
					$msg = "<ul>";
					foreach ($svn->error_list as $error) {
						$msg.="<li>".$error."</li>";
					}
					$msg.="</ul>";
					$smarty->assign("msg", $msg);
				}
				
				$smarty->assign("tpl", "result.tpl");
				break;
		
				
			//Ein Repository verndern
			case "edit_rep":
			
				if ($_POST['delete'])
				{
					$res = $svn->deleteRepository($_POST['rep_name']);
					if ($res)
						$smarty->assign("msg", "Repository wurde gelscht");
					else {
						$msg = "<ul>";
						foreach ($svn->error_list as $error) {
							$msg.="<li>".$error."</li>";
						}
						$msg.="</ul>";
						$smarty->assign("msg", $msg);
					}
				} elseif ($_POST['save'])
				{
					//Fr jeden Benutzer mssen nun die Rechte gendert werden und eventuell das Passwort
					$res = true;
					foreach ($_POST['user'] as $user => $values) {
						
						$tmp = $svn->changeUserRights($user, $_POST['rep_name'], $values['rights']);
						
						//Alles funktioniert?
						$res = $tmp && $res;
						
					}
					
					
					$res2 = true;
					if (is_array($_POST['delete_u']))
					{
						foreach ($_POST['delete_u'] as $user => $set) {
							
							if ($set == "on")
							{ 
								$tmp2 = $svn->removeUserFromRepository($user, $_POST['rep_name']);
								$res2 = $tmp2 && $res2;
							}
						}
					}
					
					
					if ($res && $res2) {
						
						$smarty->assign("msg", "Das Repository wurde verndert.");
					}
					else {
						$msg = "<ul>";
						foreach ($svn->error_list as $error) {
							$msg.="<li>".$error."</li>";
						}
						$msg.="</ul>";
						$smarty->assign("msg", $msg);
					}
					
				}
			
				$smarty->assign("tpl", "result.tpl");
				break;
				
			//Einen Benutzer zum Projekt hinzufgen
			case "add_u":
			
				//benutzer hinzu
				$res = $svn->addUserToRepository($_POST['user'], $_POST['rep_name'], $_POST['rights']);
				
				if ($res)
					$smarty->assign("msg", "Benutzer wurde dem Repository hinzugefgt");
				else {
					$msg = "<ul>";
					foreach ($svn->error_list as $error) {
						$msg.="<li>".$error."</li>";
					}
					$msg.="</ul>";
					$smarty->assign("msg", $msg);
				}
				
				$smarty->assign("tpl", "result.tpl");
				break;
				
			default:
				break;
		}
	
	
		break;
		
	default:
		
		$smarty->assign("tpl", "result.tpl");
		$smarty->assign("msg", "Bitte treffen Sie eine Auswahl");
		break;
}


//Anzeigen des Hauptemplates
$smarty->display("front_main.tpl");

?>