<?php
/**
* Copyright (C) 2005  Martin Grund
*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
*  License as published by the Free Software Foundation; either
*  version 2.1 of the License, or (at your option) any later version.
*
*  This library is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*  Lesser General Public License for more details.
*
*  You should have received a copy of the GNU Lesser General Public
*  License along with this library; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*/
class IniController {

	
	function parse_ini_file($filename, $process_sections = true)
	{
		
		//Laden der INI
		return parse_ini_file($filename, true);
		
	}
	
	
	function save_ini_file($filename, $hash, $process_sections = true, $ignoreOwner = false)
	{
		$fc = "";
		
		if ($ignoreOwner)
		{
			$hash["/"] = array("*" => "");
		}
		
		//Unterschieden wird bei Gruppen ob ein Array ist oder nicht
		foreach ($hash as $key => $section) {
			
			//Wenn Sektionen, dann die unterteile auch abfragen
			if ($process_sections)
			{
				if ($ignoreOwner)
					$additionalText = ":/";
				else 
					$additionalText = "";
				
				$string = "[".$key.$additionalText."]\n";
				
				if (is_array($section))
				{
					foreach ($section as $sk => $sv) {
						
						if ($ignoreOwner && $sk== "owner")
							$string.="";
						else 
							$string.=$sk."=".$sv."\n";
						
					}
				}
				
				$fc.= "\n".$string;
				
			} else {
				
				
				$fc.="$key = $section \n";
				
			}
			
		}
		
		
		//Nun den Inhalt schreiben
		$fid = fopen($filename, "w+");
		if ($fid)
		{
			fwrite($fid, $fc);
			fclose($fid);
		} else 
			return false;
		
		return true;
	}
	
	
}

?>